unit SciKeyBindings;

interface
Uses
  Windows, Classes, Controls, SciSupport;

Type
  TSciKey = Cardinal;

  function KeyToSciKey(keyIn : word) : word;
  function SciKeyToKey(keyIn : word) : word;
  function ShiftStateToSciMode(Shift : TShiftState) : word;
  function SciModeToShiftState(SciMode : word) : TShiftState;
  function SciKey(Key, Mode : word): TSciKey;
  function SciKeyToShortCut(Key : TSciKey) : TShortCut;
  function ShortCutToSciKey(ShortCut : TShortCut) : TSciKey;

const
  SCI_NORM : word = 0;
  SCI_SHIFT : word = SCMOD_SHIFT;
  SCI_CTRL : word  = SCMOD_CTRL;
  SCI_ALT : word  = SCMOD_ALT;
  SCI_ASHIFT : word = SCMOD_ALT or SCMOD_SHIFT;
  SCI_CSHIFT : word = SCMOD_CTRL or SCMOD_SHIFT;
  VK_OEM_1 : word = $BA;
  VK_OEM_2 : word = $BF;
  VK_OEM_3 : word = $C0;
  VK_OEM_4 : word = $DB;
  VK_OEM_5 : word = $DC;
  VK_OEM_6 : word = $DD;

  Sci_KeyboardCommandMap: array[0..85] of TIdentMapEntry = (
    (Value: SCI_Null;                     Name: 'No Command'),
    (Value: SCI_CLEAR;                    Name: 'Clear'),
    (Value: SCI_COPY;                     Name: 'Copy'),
    (Value: SCI_CUT;                      Name: 'Cut'),
    (Value: SCI_PASTE;                    Name: 'Paste'),
    (Value: SCI_ZOOMIN;                   Name: 'Zoom in'),
    (Value: SCI_ZOOMOUT;                  Name: 'Zoom out'),
    (Value: SCI_SETZOOM;                  Name: 'Reset Zoom'),
    (Value: SCI_SELECTALL;                Name: 'Select All'),
    (Value: SCI_UNDO;                     Name: 'Undo'),
    (Value: SCI_REDO;                     Name: 'Redo'),
    (Value: SCI_LINEDOWN;                 Name: 'Line Down'),
    (Value: SCI_LINEDOWNEXTEND;           Name: 'Line Down Extend'),
    (Value: SCI_LINEDOWNRECTEXTEND;       Name: 'Line Down Rect Extend'),
    (Value: SCI_LINESCROLLDOWN;           Name: 'Line Scroll Extend'),
    (Value: SCI_LINEUP;                   Name: 'Line Up'),
    (Value: SCI_LINEUPEXTEND;             Name: 'Line Up Extend'),
    (Value: SCI_LINEUPRECTEXTEND;         Name: 'Line Up Rect Extend'),
    (Value: SCI_LINESCROLLUP;             Name: 'Line Scroll Up'),
    (Value: SCI_PARADOWN;                 Name: 'Line Para Down'),
    (Value: SCI_PARADOWNEXTEND;           Name: 'Para Down Extend'),
    (Value: SCI_PARAUP;                   Name: 'Line Para Up'),
    (Value: SCI_PARAUPEXTEND;             Name: 'Para Up Extend'),
    (Value: SCI_CHARLEFT;                 Name: 'Char Left'),
    (Value: SCI_CHARLEFTEXTEND;           Name: 'Char Left Extend'),
    (Value: SCI_CHARLEFTRECTEXTEND;       Name: 'Char Left Rect Extend'),
    (Value: SCI_CHARRIGHT;                Name: 'Char Right'),
    (Value: SCI_CHARRIGHTEXTEND;          Name: 'Char Right Extend'),
    (Value: SCI_CHARRIGHTRECTEXTEND;      Name: 'Char Right Rect Extend'),
    (Value: SCI_WORDLEFT;                 Name: 'Word Left'),
    (Value: SCI_WORDLEFTEXTEND;           Name: 'Word Left Extend'),
    (Value: SCI_WORDRIGHT;                Name: 'Word Right'),
    (Value: SCI_WORDRIGHTEXTEND;          Name: 'Word Right Extend'),
    //(Value: SCI_WORDLEFTEND;              Name: 'Word Left End'),
    //(Value: SCI_WORDLEFTENDEXTEND;        Name: 'Word Left End Extend'),
    //(Value: SCI_WORDRIGHTEND;             Name: 'Word Right End'),
    //(Value: SCI_WORDRIGHTENDEXTEND;       Name: 'Word Right End Extend'),
    (Value: SCI_WORDPARTLEFT;             Name: 'Word Part Left'),
    (Value: SCI_WORDPARTLEFTEXTEND;       Name: 'Word Part Left Extend'),
    (Value: SCI_WORDPARTRIGHT;            Name: 'Word Part Right'),
    (Value: SCI_WORDPARTRIGHTEXTEND;      Name: 'Word Part Right Extend'),
    (Value: SCI_HOME;                     Name: 'Home'),
    (Value: SCI_HOMEEXTEND;               Name: 'Home Extend'),
    (Value: SCI_HOMERECTEXTEND;           Name: 'Home Rect Extend'),
    (Value: SCI_HOMEDISPLAY;              Name: 'Home Display'),
    (Value: SCI_HOMEDISPLAYEXTEND;        Name: 'Home Display Extend'),
    (Value: SCI_HOMEWRAP;                 Name: 'Home Wrap'),
    (Value: SCI_HOMEWRAPEXTEND;           Name: 'Home Wrap Extend'),
    (Value: SCI_VCHOME;                   Name: 'VC Home'),
    (Value: SCI_VCHOMEEXTEND;             Name: 'VC Home Extend'),
    (Value: SCI_VCHOMERECTEXTEND;         Name: 'VC Home Rect Extend'),
    (Value: SCI_VCHOMEWRAP;               Name: 'VC Home Wrap'),
    (Value: SCI_VCHOMEWRAPEXTEND;         Name: 'VC Home Wrap Extend'),
    (Value: SCI_LINEEND;                  Name: 'Line End'),
    (Value: SCI_LINEENDEXTEND;            Name: 'Line End Extend'),
    (Value: SCI_LINEENDRECTEXTEND;        Name: 'Line End Rect Extend'),
    (Value: SCI_LINEENDDISPLAY;           Name: 'Line End Display'),
    (Value: SCI_LINEENDDISPLAYEXTEND;     Name: 'Line End Display Extend'),
    (Value: SCI_LINEENDWRAP;              Name: 'Line End Wrap'),
    (Value: SCI_LINEENDWRAPEXTEND;        Name: 'Line End Wrap Extend'),
    (Value: SCI_DOCUMENTSTART;            Name: 'Document Start'),
    (Value: SCI_DOCUMENTSTARTEXTEND;      Name: 'Document Start Extend'),
    (Value: SCI_DOCUMENTEND;              Name: 'Document End'),
    (Value: SCI_DOCUMENTENDEXTEND;        Name: 'Document End Extend'),
    (Value: SCI_PAGEUP;                   Name: 'Page Up'),
    (Value: SCI_PAGEUPEXTEND;             Name: 'Page Up Extend'),
    (Value: SCI_PAGEUPRECTEXTEND;         Name: 'Page Up Rect Extend'),
    (Value: SCI_PAGEDOWN;                 Name: 'Page Down'),
    (Value: SCI_PAGEDOWNEXTEND;           Name: 'Page Down Extend'),
    (Value: SCI_PAGEDOWNRECTEXTEND;       Name: 'Page Down Rect Extend'),
    //(Value: SCI_STUTTEREDPAGEUP;          Name: 'Stuttered Page Up'),
    //(Value: SCI_STUTTEREDPAGEUPEXTEND;    Name: 'Stuttered Page Up Extend'),
    //(Value: SCI_STUTTEREDPAGEDOWN;        Name: 'Stuttered Page Down'),
    //(Value: SCI_STUTTEREDPAGEDOWNEXTEND;  Name: 'Stuttered Page Down Extend'),
    (Value: SCI_DELETEBACK;               Name: 'Delete Back'),
    (Value: SCI_DELETEBACKNOTLINE;        Name: 'Delete Back Not Line'),
    (Value: SCI_DELWORDLEFT;              Name: 'Delete Word Left'),
    (Value: SCI_DELWORDRIGHT;             Name: 'Delete Word Right'),
    (Value: SCI_DELLINELEFT;              Name: 'Delete Line Left'),
    (Value: SCI_DELLINERIGHT;             Name: 'Delete Line Right'),
    (Value: SCI_LINEDELETE;               Name: 'Delete Line'),
    (Value: SCI_DELWORDRIGHT;             Name: 'Delete Word Right'),
    (Value: SCI_LINECUT;                  Name: 'Line Cut'),
    (Value: SCI_LINECOPY;                 Name: 'Line Copy'),
    (Value: SCI_LINETRANSPOSE;            Name: 'Line Transpose'),
    (Value: SCI_LINEDUPLICATE;            Name: 'Line Duplicate'),
    (Value: SCI_LOWERCASE;                Name: 'Lower Case'),
    (Value: SCI_UPPERCASE;                Name: 'Upper Case'),
    (Value: SCI_CANCEL;                   Name: 'Cancel'),
    (Value: SCI_EDITTOGGLEOVERTYPE;       Name: 'Toggle Overtype'),
    (Value: SCI_NEWLINE;                  Name: 'New Line'),
    (Value: SCI_FORMFEED;                 Name: 'Form Feed'),
    (Value: SCI_TAB;                      Name: 'Tab'),
    (Value: SCI_BACKTAB;                  Name: 'Back Tab'));

Type

  TSciKeyCommand = class(TCollectionItem)
  private
    FCommand: Integer;
    FShortCut : TShortCut;
    procedure SetCommand(const Value: integer);
    procedure SetShortCut(const Value: TShortCut);
  protected
    function GetDisplayName: string; override;
  public
    constructor Create(Collection: TCollection); override;
    procedure Assign(Source: TPersistent); override;
  published
    property Command: integer read FCommand write SetCommand;
    property ShortCut: TShortCut read FShortCut write SetShortCut;
  end;

  TSciKeyCommandCollection = class(TCollection)
  private
    fEditor : TWinControl; //TScintilla
  protected
    procedure SetEditor(Editor : TWinControl);
  public
    constructor Create(Editor : TWinControl);
    procedure Update(Item: TCollectionItem); override;
    procedure AddCommandKey(Key, Mode : word; Command : integer);
    procedure ResetDefaultCommands;
    function FindShortCut(ShortCut: TShortCut) : TSciKeyCommand;
    property Editor : TWinControl read FEditor write SetEditor;
  end;


implementation

Uses
  SciLexer, Menus;

function KeyToSciKey(keyIn : word) : word;
begin
	case keyIn of
		VK_DOWN:		 Result := SCK_DOWN;
		VK_UP:		   Result := SCK_UP;
		VK_LEFT:		 Result := SCK_LEFT;
		VK_RIGHT:	   Result := SCK_RIGHT;
		VK_HOME:		 Result := SCK_HOME;
		VK_END:		   Result := SCK_END;
		VK_PRIOR:	   Result := SCK_PRIOR;
		VK_NEXT:		 Result := SCK_NEXT;
		VK_DELETE:	 Result := SCK_DELETE;
		VK_INSERT:	 Result := SCK_INSERT;
		VK_ESCAPE:	 Result := SCK_ESCAPE;
		VK_BACK:		 Result := SCK_BACK;
		VK_TAB:		   Result := SCK_TAB;
		VK_Return:   Result := SCK_RETURN;
		VK_ADD:		   Result := SCK_ADD;
		VK_SUBTRACT: Result := SCK_SUBTRACT;
		VK_DIVIDE:	 Result := SCK_DIVIDE;
		else			   Result := keyIn;
	end;
end;


function SciKeyToKey(keyIn : word) : word;
begin
	case keyIn of
		SCK_DOWN:		 Result := VK_DOWN;
		SCK_UP:		   Result := VK_UP;
		SCK_LEFT:		 Result := VK_LEFT;
		SCK_RIGHT:	 Result := VK_RIGHT;
		SCK_HOME:		 Result := VK_HOME;
		SCK_END:		 Result := VK_END;
		SCK_PRIOR:	 Result := VK_PRIOR;
		SCK_NEXT:		 Result := VK_NEXT;
		SCK_DELETE:	 Result := VK_DELETE;
		SCK_INSERT:	 Result := VK_INSERT;
		SCK_ESCAPE:	 Result := VK_ESCAPE;
		SCK_BACK:		 Result := VK_BACK;
		SCK_TAB:		 Result := VK_TAB;
		SCK_Return:  Result := VK_RETURN;
		SCK_ADD:		 Result := VK_ADD;
		SCK_SUBTRACT:Result := VK_SUBTRACT;
		SCK_DIVIDE:	 Result := VK_DIVIDE;
    Ord(';'):    Result := VK_OEM_1;
    Ord('/'):    Result := VK_OEM_2;
    Ord('`'):    Result := VK_OEM_3;
    Ord('['):    Result := VK_OEM_4;
    Ord('\'):    Result := VK_OEM_5;
    Ord(']'):    Result := VK_OEM_6;
		else			   Result := keyIn;
	end;
end;

function ShiftStateToSciMode(Shift : TShiftState) : word;
begin
  Result := 0;
  if ssShift in Shift then Result := Result or SCMOD_SHIFT;
  if ssCtrl  in Shift then Result := Result or SCMOD_CTRL;
  if ssAlt in Shift then Result := Result or SCMOD_ALT;
end;

function SciKey(Key, Mode : word): TSciKey;
begin
  Result := (Cardinal(Mode) shl 16) or Cardinal(Key);
end;

function SciModeToShiftState(SciMode : word) : TShiftState;
begin
  Result := [];
  if SciMode and SCMOD_SHIFT <> 0 then Include(Result, ssShift);
  if SciMode and SCMOD_CTRL <> 0 then Include(Result, ssCtrl);
  if SciMode and SCMOD_ALT <> 0 then Include(Result, ssAlt);
end;

function SciKeyToShortCut(Key : TSciKey) : TShortCut;
begin
  Result := ShortCut(SciKeyToKey(LoWord(Key)), SciModeToShiftState(HiWord(Key)));
end;

function ShortCutToSciKey(ShortCut : TShortCut) : TSciKey;
var
  Key: Word;
  Shift: TShiftState;
begin
  ShortCutToKey(ShortCut, Key, Shift);
  Result := (Cardinal(ShiftStateToSciMode(Shift)) shl 16) or Cardinal(KeyToSciKey(Key));
end;


{ TSciKeyCommandCollection }

procedure TSciKeyCommandCollection.AddCommandKey(Key, Mode: word;
  Command: integer);
Var
  KeyCommand : TSciKeyCommand;
begin
  KeyCommand := Add as TSciKeyCommand;
  KeyCommand.FCommand := Command;
  KeyCommand.FShortCut := SciKeyToShortCut(SciKey(Key, Mode));
end;

constructor TSciKeyCommandCollection.Create(Editor: TWinControl);
begin
  inherited Create(TSciKeyCommand);
  FEditor := Editor;
  ResetDefaultCommands;
end;

function TSciKeyCommandCollection.FindShortCut(
  ShortCut: TShortCut): TSciKeyCommand;
var
  i : integer;
  KeyCommand : TSciKeyCommand;
begin
  Result := nil;
  for i := 0 to Count - 1 do begin
    KeyCommand := Items[i] as TSciKeyCommand;
    if KeyCommand.ShortCut = ShortCut then begin
      Result := KeyCommand;
      Exit;
    end;
  end;
end;

procedure TSciKeyCommandCollection.ResetDefaultCommands;
begin
  // Set Default Commands
  BeginUpdate;
  try
    Clear;
    AddCommandKey(SCK_DOWN,		SCI_NORM,	  SCI_LINEDOWN);
    AddCommandKey(SCK_DOWN,		SCI_SHIFT,	SCI_LINEDOWNEXTEND);
    AddCommandKey(SCK_DOWN,		SCI_CTRL,	  SCI_LINESCROLLDOWN);
    AddCommandKey(SCK_DOWN,		SCI_ASHIFT,	SCI_LINEDOWNRECTEXTEND);
    AddCommandKey(SCK_UP,		  SCI_NORM,	  SCI_LINEUP);
    AddCommandKey(SCK_UP,			SCI_SHIFT,	SCI_LINEUPEXTEND);
    AddCommandKey(SCK_UP,			SCI_CTRL,	  SCI_LINESCROLLUP);
    AddCommandKey(SCK_UP,		  SCI_ASHIFT,	SCI_LINEUPRECTEXTEND);
    AddCommandKey(Ord('['),		SCI_CTRL,		SCI_PARAUP);
    AddCommandKey(Ord('['),		SCI_CSHIFT,	SCI_PARAUPEXTEND);
    AddCommandKey(Ord(']'),		SCI_CTRL,		SCI_PARADOWN);
    AddCommandKey(Ord(']'),		SCI_CSHIFT,	SCI_PARADOWNEXTEND);
    AddCommandKey(SCK_LEFT,		SCI_NORM,	  SCI_CHARLEFT);
    AddCommandKey(SCK_LEFT,		SCI_SHIFT,	SCI_CHARLEFTEXTEND);
    AddCommandKey(SCK_LEFT,		SCI_CTRL,	  SCI_WORDLEFT);
    AddCommandKey(SCK_LEFT,		SCI_CSHIFT,	SCI_WORDLEFTEXTEND);
    AddCommandKey(SCK_LEFT,		SCI_ASHIFT,	SCI_CHARLEFTRECTEXTEND);
    AddCommandKey(SCK_RIGHT,	SCI_NORM,	  SCI_CHARRIGHT);
    AddCommandKey(SCK_RIGHT,	SCI_SHIFT,	SCI_CHARRIGHTEXTEND);
    AddCommandKey(SCK_RIGHT,	SCI_CTRL,	  SCI_WORDRIGHT);
    AddCommandKey(SCK_RIGHT,	SCI_CSHIFT,	SCI_WORDRIGHTEXTEND);
    AddCommandKey(SCK_RIGHT,	SCI_ASHIFT,	SCI_CHARRIGHTRECTEXTEND);
    AddCommandKey(Ord('/'),		SCI_CTRL,		SCI_WORDPARTLEFT);
    AddCommandKey(Ord('/'),		SCI_CSHIFT,	SCI_WORDPARTLEFTEXTEND);
    AddCommandKey(Ord('\'),		SCI_CTRL,		SCI_WORDPARTRIGHT);
    AddCommandKey(Ord('\'),		SCI_CSHIFT,	SCI_WORDPARTRIGHTEXTEND);
    AddCommandKey(SCK_HOME,		SCI_NORM,	  SCI_VCHOME);
    AddCommandKey(SCK_HOME, 	SCI_SHIFT, 	SCI_VCHOMEEXTEND);
    AddCommandKey(SCK_HOME, 	SCI_CTRL, 	SCI_DOCUMENTSTART);
    AddCommandKey(SCK_HOME, 	SCI_CSHIFT, SCI_DOCUMENTSTARTEXTEND);
    AddCommandKey(SCK_HOME, 	SCI_ALT, 	  SCI_HOMEDISPLAY);
    AddCommandKey(SCK_HOME,		SCI_ASHIFT,	SCI_VCHOMERECTEXTEND);
    AddCommandKey(SCK_END,	 	SCI_NORM,	  SCI_LINEEND);
    AddCommandKey(SCK_END,	 	SCI_SHIFT, 	SCI_LINEENDEXTEND);
    AddCommandKey(SCK_END, 		SCI_CTRL, 	SCI_DOCUMENTEND);
    AddCommandKey(SCK_END, 		SCI_CSHIFT, SCI_DOCUMENTENDEXTEND);
    AddCommandKey(SCK_END, 		SCI_ALT, 	  SCI_LINEENDDISPLAY);
    AddCommandKey(SCK_END,		SCI_ASHIFT,	SCI_LINEENDRECTEXTEND);
    AddCommandKey(SCK_PRIOR,	SCI_NORM,	  SCI_PAGEUP);
    AddCommandKey(SCK_PRIOR,	SCI_SHIFT, 	SCI_PAGEUPEXTEND);
    AddCommandKey(SCK_PRIOR,	SCI_ASHIFT,	SCI_PAGEUPRECTEXTEND);
    AddCommandKey(SCK_NEXT, 	SCI_NORM, 	SCI_PAGEDOWN);
    AddCommandKey(SCK_NEXT, 	SCI_SHIFT, 	SCI_PAGEDOWNEXTEND);
    AddCommandKey(SCK_NEXT,		SCI_ASHIFT,	SCI_PAGEDOWNRECTEXTEND);
    AddCommandKey(SCK_DELETE, SCI_NORM,	  SCI_CLEAR);
    AddCommandKey(SCK_DELETE, SCI_SHIFT,	SCI_CUT);
    AddCommandKey(SCK_DELETE, SCI_CTRL,	  SCI_DELWORDRIGHT);
    AddCommandKey(SCK_DELETE,	SCI_CSHIFT,	SCI_DELLINERIGHT);
    AddCommandKey(SCK_INSERT, SCI_NORM,	  SCI_EDITTOGGLEOVERTYPE);
    AddCommandKey(SCK_INSERT, SCI_SHIFT,	SCI_PASTE);
    AddCommandKey(SCK_INSERT, SCI_CTRL,	  SCI_COPY);
    AddCommandKey(SCK_ESCAPE, SCI_NORM,	  SCI_CANCEL);
    AddCommandKey(SCK_BACK,		SCI_NORM, 	SCI_DELETEBACK);
    AddCommandKey(SCK_BACK,		SCI_SHIFT, 	SCI_DELETEBACK);
    AddCommandKey(SCK_BACK,		SCI_CTRL, 	SCI_DELWORDLEFT);
    AddCommandKey(SCK_BACK, 	SCI_ALT,	  SCI_UNDO);
    AddCommandKey(SCK_BACK,		SCI_CSHIFT,	SCI_DELLINELEFT);
    AddCommandKey(Ord('Z'), 	SCI_CTRL,	  SCI_UNDO);
    AddCommandKey(Ord('Y'), 	SCI_CTRL,	  SCI_REDO);
    AddCommandKey(Ord('X'), 	SCI_CTRL,	  SCI_CUT);
    AddCommandKey(Ord('C'), 	SCI_CTRL,	  SCI_COPY);
    AddCommandKey(Ord('V'), 	SCI_CTRL,	  SCI_PASTE);
    AddCommandKey(Ord('A'), 	SCI_CTRL,	  SCI_SELECTALL);
    AddCommandKey(SCK_TAB,		SCI_NORM,	  SCI_TAB);
    AddCommandKey(SCK_TAB,		SCI_SHIFT,	SCI_BACKTAB);
    AddCommandKey(SCK_RETURN, SCI_NORM,	  SCI_NEWLINE);
    AddCommandKey(SCK_RETURN, SCI_SHIFT,	SCI_NEWLINE);
    AddCommandKey(SCK_ADD, 		SCI_CTRL,	  SCI_ZOOMIN);
    AddCommandKey(SCK_SUBTRACT,SCI_CTRL,	SCI_ZOOMOUT);
    AddCommandKey(SCK_DIVIDE,	SCI_CTRL,	  SCI_SETZOOM);
    AddCommandKey(Ord('L'), 	SCI_CTRL,	  SCI_LINECUT);
    AddCommandKey(Ord('L'), 	SCI_CSHIFT,	SCI_LINEDELETE);
    AddCommandKey(Ord('T'), 	SCI_CSHIFT,	SCI_LINECOPY);
    AddCommandKey(Ord('T'), 	SCI_CTRL,	  SCI_LINETRANSPOSE);
    AddCommandKey(Ord('D'), 	SCI_CTRL,	  SCI_LINEDUPLICATE);
    AddCommandKey(Ord('U'), 	SCI_CTRL,	  SCI_LOWERCASE);
    AddCommandKey(Ord('U'), 	SCI_CSHIFT,	SCI_UPPERCASE);
  finally
    EndUpdate;
  end;
end;

procedure TSciKeyCommandCollection.SetEditor(Editor: TWinControl);
begin
  FEditor := Editor;
end;

procedure TSciKeyCommandCollection.Update(Item: TCollectionItem);
Var
  i : integer;
begin
  inherited;
  if (not Assigned(fEditor)) or (not FEditor.HandleAllocated) then Exit;
  if Assigned(Item) then with (Item as TSciKeyCommand) do
      TScintilla(fEditor).AssignCmdKey(ShortCutToSciKey(FShortCut), FCommand)
  else begin
    TScintilla(fEditor).ClearAllCmdKeys;
    for i := 0 to Count - 1 do with (Items[i] as TSciKeyCommand) do
      TScintilla(fEditor).AssignCmdKey(ShortCutToSciKey(FShortCut), FCommand);
  end;
end;


{ TSciKeyCommand }

procedure TSciKeyCommand.Assign(Source: TPersistent);
begin
  if Source is TSciKeyCommand then begin
    FShortCut := TSciKeyCommand(Source).FShortCut;
    FCommand := TSciKeyCommand(Source).FCommand;
  end else
    inherited;
end;

constructor TSciKeyCommand.Create(Collection: TCollection);
begin
  inherited;
  FCommand := SCI_NULL;
end;

function TSciKeyCommand.GetDisplayName: string;
begin
  if ShortCut = 0 then
    Result := 'No Key'
  else
    Result := ShortCutToText(FShortCut);
end;

procedure TSciKeyCommand.SetCommand(const Value: Integer);
begin
  FCommand := Value;
  Changed(False);
end;

procedure TSciKeyCommand.SetShortCut(const Value: TShortCut);
begin
  FShortCut := Value;
  Changed(False);
end;

end.
