unit SciLexerReg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

procedure Register;

implementation
Uses
  DesignIntf, DesignEditors, SciLexer, EdOptionsWin, SciLexerOptionsDlg, SciSearchReplace,
  SciKeyBindings;

Type
  TScintillaComponentEditor = class(TComponentEditor)
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

  TSciKeyCommandsPropertyEditor = class(TPropertyEditor)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
  end;


procedure Register;
begin
  RegisterComponents( 'Scintilla', [ TScintilla, TScintillaOptionsDlg, TSciSearchReplace ] );
  RegisterComponentEditor(TScintilla, TScintillaComponentEditor);
  RegisterPropertyEditor(TypeInfo(TSciKeyCommandCollection), TScintilla, '', TSciKeyCommandsPropertyEditor);
end;

{ TScintillaComponentEditor }

procedure TScintillaComponentEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0 : 
      begin
        with TEdOptionsWindow.Create(nil) do begin
          Scintilla := TScintilla(Component);
          ShowModal;
          Free;
        end;
      end;
  end;
end;

function TScintillaComponentEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0 : Result := 'Options';
  end;
end;

function TScintillaComponentEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

{ TSciKeyCommandsPropertyEditor }

procedure TSciKeyCommandsPropertyEditor.Edit;
begin
  with TScintillaOptionsDlg.Create(nil) do begin
    Scintilla := GetComponent(0) as TScintilla;
    if Assigned(Scintilla) then begin
      Pages := [opKeyboard];
      ActivePage := opKeyboard;
      Execute;
    end;
    Free;
  end;
end;

function TSciKeyCommandsPropertyEditor.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

function TSciKeyCommandsPropertyEditor.GetValue: string;
begin
  Result := Format('(%s)', ['KeyCommands']);
end;

end.
